Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.SlaveTrayIcon/Program.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.SlaveTrayIcon/Program.cs	(revision 6115)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.SlaveTrayIcon/Program.cs	(revision 6116)
@@ -1,4 +1,6 @@
 ﻿using System;
 using System.Diagnostics;
+using System.Management;
+using System.Security.Principal;
 using System.Windows.Forms;
 using HeuristicLab.Clients.Hive.SlaveCore.Views;
@@ -23,8 +25,35 @@
 
     /// <summary>
+    /// Gets the owner of a process
+    /// (based on http://www.codeproject.com/KB/cs/processownersid.aspx)
+    /// </summary>    
+    public static string GetProcessOwner(int pid) {
+      string ownerSID = String.Empty;
+      string processName = String.Empty;
+      try {
+        ObjectQuery sq = new ObjectQuery
+            ("Select * from Win32_Process Where ProcessID = '" + pid + "'");
+        ManagementObjectSearcher searcher = new ManagementObjectSearcher(sq);
+        if (searcher.Get().Count == 0)
+          return ownerSID;
+        foreach (ManagementObject oReturn in searcher.Get()) {
+          string[] sid = new String[1];
+          oReturn.InvokeMethod("GetOwnerSid", (object[])sid);
+          ownerSID = sid[0];
+          return ownerSID;
+        }
+      }
+      catch {
+        return ownerSID;
+      }
+      return ownerSID;
+    }
+
+    /// <summary>
     /// kill all other slave tray icons, we only want 1 running at a time
     /// (and if a newer version is installed the older one should be killed)
     /// </summary>
     private static void KillOtherInstances() {
+      String currentUserSID = WindowsIdentity.GetCurrent().User.Value;
       Process curProc = Process.GetCurrentProcess();
 
@@ -33,10 +62,12 @@
         foreach (Process p in procs) {
           if (p.Id != curProc.Id) {
-            p.Kill();
+            String procUserSID = GetProcessOwner(p.Id);
+            if (procUserSID == currentUserSID) {
+              p.Kill();
+            }
           }
         }
       }
-      catch (InvalidOperationException) {
-      }
+      catch (InvalidOperationException) { }
       catch (Exception) {
         MessageBox.Show("There is another instance of the Hive Slave tray icon running which can't be closed.", "HeuristicLab Hive Slave");
